### deploy
The `deploy` task deploys files using the deploy section in a user's local 'gulpw-config.*' and also uses a user level deploy configuration generated by
the 'deploy-config' task.  See notes in config section below.

##### In gulpw-config.*:
```
tasks:
 # Deploy Task
  deploy:

    # Use unix style paths for deployment
    deployUsingUnixStylePaths: true

    # Options written by `deploy-config` to `.gulpw/deploy.yaml`
    developingDomain: null
    hostnamePrefix: null
    hostname: null
    port: 22
    username: null
    password: null
    publickeyPassphrase: null
    privatekeyLocation: null

    # File types that are allowed for deployment
    allowedFileTypes: # This will change to `ingoredFileTypes`
      - js
      - css
      - html
      - json
      - yaml
      - jpg
      - png
      - gif
      - md
      - mkd

    # Domains to develop
    domainsToDevelop:

      # Hostname to develop for
      somedomain.com:

        # Servers where user can deploy to `domainToDevelopFor`
        # (in this case `domainToDevelopFor` is `somedomain.com`)
        hostnames: # slots/hosts
          - -devslot1.somedomain.com
          - -devslot2.somedomain.com
          - -devslot3.somedomain.com

        # All website instance prefixes represent the same website just different
        # instances of the website.

        # An array of hostname prefixes (if any)
        hostnamePrefixes:
          - web1
          - web2
          - web3

        # If set a `hostnamePrefixFolder` value becomes available
        # to any templates within this `domainToDevelopConfig[x]` config.
        hostnamePrefixFolders: null
          #web1: website1
          #web2: website2
          #web3: website3

        # Root folder on the server to use for deployments (prefix
        # path for file paths being deployed that don't have
        # `deployRootFoldersByFileType` defined for their typ)))
        # example: /home/some-user/sites/<%= hostnamePrefix %><%= hostname %>
        # (recieves the `deploy` has from this config)
        deployRootFolder: null

        # Deploy roots by file type. If defined, file types that are keys in
        # it's hash will have the deploy root for said key
        # prepend as a deploy root to the file being deployed instead of the
        # `deployRootFolder` root path.
        deployRootFoldersByFileType:
          md: /home/some-user/docroot/md-files.<%= hostnamePrefix %><%= hostname %>/

        # A map used to replace parts or all of paths found that match the pattern on the left with the value on the right
        # Used for complex setups where the paths in your development environment don't have a one-to-one counterpart on the
        # Server;  E.g., One of my setups has ./jsp/some/file.jsp locally but on the server it is ./some-other-folder/some/file.jsp
        # So this isn't something that can be acheived with a root folder prefix because the local path ./jsp/... is in the root development directory
        # and when deploying we deploy ./jsp/... => /{some-deploy-root}/jsp/...
        localPathsToServerPathsRegexMap:
          '^(?:\.\/)?jsp\/': 'some-necessarily-differently-named-dir-on-the-server/'

```
